// pl0_init.c 初始化程序

#include "pl0.h"

long sym;		// last symbol read
char id[al+1];	// last identifier read
long num;		// last number read

long ll = 1;			// line length			// 修改为初值为1是为了方便验证。
long cc = 1;			// character count		// 修改为初值为1是为了方便验证。

char line[81] = {' ', ' ', };	// 下标为0的单元不使用。

char ch = ' ';			// last character read

long kk = al;

long err = 0;

char a[al+1] = {'a', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '\0'};

instruction code[cxmax+1];
long cx = 0;			// code allocation index

char word[norw][al+1] = {"begin     ", "call      ", "const     ", "do        ",
"end       ", "if        ", "odd       ", "procedure ", "then      ",
"var       ", "while     "};

long wsym[norw] = {beginsym, callsym, constsym, dosym, endsym, ifsym, oddsym,
procsym, thensym, varsym, whilesym};

long ssym[256] = 
{nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
lparen, rparen, times, plus, comma, minus, period, slash, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, semicolon,
nul, eql, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul,
nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul, nul}; 

char mnemonic[8][3+1] = {"lit", "opr", "lod", "sto", "cal", "int", "jmp", "jpc"};

long declbegsys = constsym | varsym | procsym,
    statbegsys = beginsym|callsym|ifsym|whilesym,
    facbegsys = ident|number|lparen;

long tx = 0;		// current table index

struct name_tab table[txmax+1];


char infilename[80];
FILE* infile;

// the following variables for block
long dx = 0;		// data allocation index
long lev = 0;		// current depth of block nesting

// the following array space for interpreter
#define stacksize 50000
long s[stacksize];	// datastore

